<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="老师姓名" prop="teacherName">
        <el-input v-model="queryParams.teacherName" placeholder="请输入老师姓名" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['hezhi:teacherCourse:add']">新增</el-button>
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="success"-->
      <!--          plain-->
      <!--          icon="el-icon-edit"-->
      <!--          size="mini"-->
      <!--          :disabled="single"-->
      <!--          @click="handleUpdate"-->
      <!--          v-hasPermi="['hezhi:teacherCourse:edit']"-->
      <!--        >修改</el-button>-->
      <!--      </el-col>-->
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['hezhi:teacherCourse:remove']">删除</el-button>
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="warning"-->
      <!--          plain-->
      <!--          icon="el-icon-download"-->
      <!--          size="mini"-->
      <!--          @click="handleExport"-->
      <!--          v-hasPermi="['hezhi:teacherCourse:export']"-->
      <!--        >导出</el-button>-->
      <!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="teacherCourseList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!--      <el-table-column label="老师课程关联主键ID" align="center" prop="teacherCourseId" />-->
      <!--      <el-table-column label="老师ID" align="center" prop="teacherId" />-->
      <el-table-column label="老师名" align="center" prop="teacherName" />
      <el-table-column label="图" align="center" prop="teacherImage" width="100">
        <template slot-scope="scope">
          <image-preview :src="scope.row.teacherImage" :width="50" :height="50" />
        </template>
      </el-table-column>
      <el-table-column label="是否主讲" align="center" prop="isSpeak">
        <template slot-scope="scope">
          <span v-if="scope.row.isSpeak === 0">否</span>
          <span v-if="scope.row.isSpeak === 1">是</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="备注" align="center" prop="remarks" />-->
      <!--      <el-table-column label="排序" align="center" prop="sort" />-->
      <!--      <el-table-column label="状态" align="center" prop="status" />-->
      <!--      <el-table-column label="发布时间" align="center" prop="publicationTime" width="180">-->
      <!--        <template slot-scope="scope">-->
      <!--          <span>{{ parseTime(scope.row.publicationTime, '{y}-{m}-{d}') }}</span>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <!--      <el-table-column label="发布人" align="center" prop="publisher" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="120" fixed="right">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['hezhi:teacherCourse:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['hezhi:teacherCourse:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改老师课程关联对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="老师" prop="teacherId">
          <el-select v-model="form.teacherId" placeholder="请选择" clearable>
            <el-option v-for="dict in caseTeacherOptions" :key="dict.teacherId" :label="dict.teacherName"
              :value="dict.teacherId" />
          </el-select>
        </el-form-item>
        <el-form-item label="是否主讲" prop="isSpeak">
          <el-radio v-model="form.isSpeak" :label="0">否</el-radio>
          <el-radio v-model="form.isSpeak" :label="1">是</el-radio>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTeacherCourse, getTeacherCourse, delTeacherCourse, addTeacherCourse, updateTeacherCourse } from "@/api/hezhi/teacherCourse";
import { listCaseType } from "@/api/hezhi/caseType";
import { listTeacher } from "@/api/hezhi/teacher";

export default {
  name: "TeacherCourse",
  props: ["screenCourseId"],
  data() {
    return {
      caseTeacherOptions: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 老师课程关联表格数据
      teacherCourseList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        teacherId: null,
        courseId: null,
        isSpeak: null,
        remarks: null,
        sort: null,
        status: null,
        publicationTime: null,
        publisher: null,
        deleteTime: null,
        deleteBy: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        teacherId: [
          { required: true, trigger: "blur", message: "请选择老师" },
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    getTypeName(id) {
      const type = this.caseTeacherOptions.find(item => item.teacherId === id);
      return type.teacherName;
    },

    /** 查询老师课程关联列表 */
    getList() {
      this.loading = true;
      if (this.screenCourseId != null) {
        this.queryParams.courseId = this.screenCourseId;
      }
      listTeacherCourse(this.queryParams).then(response => {
        this.teacherCourseList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        teacherCourseId: null,
        teacherId: null,
        courseId: null,
        isSpeak: 0,
        remarks: null,
        sort: null,
        status: null,
        publicationTime: null,
        publisher: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        deleteTime: null,
        deleteBy: null,
        delFlag: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.teacherCourseId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加老师课程关联";

      this.queryParams.pageSize = 99999;
      listTeacher(this.queryParams).then(response => {
        this.caseTeacherOptions = response.rows;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const teacherCourseId = row.teacherCourseId || this.ids
      getTeacherCourse(teacherCourseId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改老师课程关联";
      });

      listTeacher().then(response => {
        this.caseTeacherOptions = response.rows;
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.teacherCourseId != null) {
            if (this.screenCourseId != null) {
              this.form.courseId = this.screenCourseId;
            }
            updateTeacherCourse(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            if (this.screenCourseId != null) {
              this.form.courseId = this.screenCourseId;
            }
            addTeacherCourse(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const teacherCourseIds = row.teacherCourseId || this.ids;
      this.$modal.confirm('是否确认删除老师课程关联编号为"' + teacherCourseIds + '"的数据项？').then(function () {
        return delTeacherCourse(teacherCourseIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('hezhi/teacherCourse/export', {
        ...this.queryParams
      }, `teacherCourse_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
